# xv6 的整体结构
---
## 1.多核支持:
- 能够支持多核 CPU 启动，并实现多核之间的基本同步与通信。
## 2.内存管理：
- 实现了物理内存分配器和虚拟内存页表管理。
- 能够使用页表映射来支持用户态和内核态地址转换。

## 3.进程管理：
- 能够从单进程扩展到多进程。
- 实现了进程调度器、进程生命周期管理（fork、exit、wait）。
- 支持用户态和内核态之间的系统调用接口。

## 4.中断与异常处理：
- 完整的中断和异常机制，支持用户态与内核态的切换。
- 支持时钟中断、外部设备中断（如 UART）以及系统调用触发的异常。

## 5. 文件系统：
- 支持磁盘设备，并实现了缓存管理机制（bio.c）。
- 引入文件系统，支持文件和目录管理：
    - 底层磁盘布局：超级块、inode、数据块、位图等。
    - 文件操作：实现文件读写、文件描述符、目录解析等功能。
    - 文件系统调用：如 open、read、write、exec 等接口。
- 支持 ELF 格式可执行文件加载（通过 exec 实现）。

---
# Our-xv6：
## 模块创新部分详见参考文档