# 用户态虚拟内存管理和系统调用流程
---
## 一、系统调用触发
- 1.用户态：用户进程设置a7为系统调用编号，a0至a5为参数。通过ecall指令触发trap，进入内核态。
- 2.内核态：trap.c中的usertrap调用syscall()。syscall()从trapframe->a7解析系统调用编号，并调用对应的处理函数。返回值存入trapframe->a0，用户态可通过a0访问返回值。
- 3.参数获取与验证：参数通过argraw从trapframe提取。如果参数是用户地址或字符串，会调用fetchaddr和fetchstr进行验证和翻译。

![alt text](image-5.png)

## 二、模块syscall.c、sysproc.c、trap.c、vm.c的协同工作
基于四个模块的相互协作，实现了用户态虚拟内存管理和系统调用流程：从系统调用的触发、进程控制、虚拟内存管理，到异常处理和进程退出，形成了完整的内核服务框架。

![alt text](image-6.png)

