/* Mutual exclusion lock.
struct spinlock {
  uint locked;       // Is the lock held?

  // For debugging:
  char *name;        // Name of lock.
  struct cpu *cpu;   // The cpu holding the lock.
};
*/

struct spinlock {
  uint locked;        // Is the lock held? (for backward compatibility)
  char *name;         // Name of lock.
  struct cpu *cpu;    // The CPU holding the lock.

  // Ticket lock fields
  uint next_ticket;   // The next ticket to acquire.
  uint current_ticket;// The current ticket being served.
};
