#include "kernel/types.h"
#include "kernel/stat.h"
#include "user/user.h"

int
main(int argc, char *argv[])
{
  if(argc != 3){
    printf("Usage: chmod <path> <mode>\n");
    exit(1);
  }

  const char *path = argv[1];
  int mode = atoi(argv[2]);

  if(chmod(path, mode) < 0) {
    printf("chmod failed\n");
    exit(1);
  }

  printf("chmod success\n");
  exit(0);
}
