## 1. 所属学校及比赛方向
|  所属学校   | 比赛方向  |
|  ----  | ----  |
| 合肥工业大学（翡翠湖校区）  | 模块实验创新 |
---

## 2. 队伍编号及队伍名称
|  队伍编号   | 队伍名称  |
|  ----  | ----  |
| @T202410359994411   | 某某队 |
---

## 3. 队伍成员及指导老师
- 队伍成员
    - 马合坤
    - 张博文
    - 于思琪
- 指导老师
    - 田卫东
    - 周红鹃
---

## 4. 项目介绍
**DOON LIST:**
- 系统调用跟踪
- 当前空闲内存/进程数
- 进程追踪
- 自旋锁性能优化
- 多级反馈队列调度器（MLFQ）

**TODO LIST**
- 进程抢占支持
- 进程的内存隔离和共享	
- 增加文件权限支持	
- 条件变量与读写锁支持	
- 支持用户态线程库	
- 支持动态内存分页	
- 实现内核页缓存	
- 扩展用户态功能	
- Shell 扩展	
- 网络支持	
- 崩溃恢复与日志系统	

---

## 5. PDF文档及过程性材料链接

![alt text](image.png)

![alt text](image-1.png)

**PDF文档详见主页文件：模块实验创新-某某队-华东区域赛.pdf**
---

## 6. 代码的参考情况及链接
- **参考XV6 for RISC-V内核代码**：<https://github.com/mit-pdos/xv6-riscv>
- **How to run?**
You will need a RISC-V "newlib" tool chain from <https://github.com/riscv/riscv-gnu-toolchain>, and qemu compiled for riscv64-softmmu.  Once they are installed, and in your shell search path, you can run "make qemu".