#include "kernel/types.h"
#include "kernel/stat.h"
#include "user/user.h"

volatile int counter = 0;

void
test_ticket_lock()
{
  int pid = fork();
  if(pid == 0){
    for(int i = 0; i < 10000; i++)
      counter++;
    exit(0);
  } else {
    for(int i = 0; i < 10000; i++)
      counter++;
    wait(0);
    printf("Final counter: %d\n", counter);
  }
}

int
main(int argc, char *argv[])
{
  test_ticket_lock();
  exit(0);
}
